    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * ------------------
    028     * PointerNeedle.java
    029     * ------------------
    030     * (C) Copyright 2002-2008, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * Changes:
    037     * --------
    038     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    039     * 26-Mar-2003 : Implemented Serializable (DG);
    040     * 09-Sep-2003 : Added equals() method (DG);
    041     * 08-Jun-2005 : Implemented Cloneable (DG);
    042     * 22-Nov-2007 : Implemented hashCode() (DG);
    043     *
    044     */
    045
    046    package org.jfree.chart.needle;
    047
    048    import java.awt.Graphics2D;
    049    import java.awt.geom.GeneralPath;
    050    import java.awt.geom.Point2D;
    051    import java.awt.geom.Rectangle2D;
    052    import java.io.Serializable;
    053
    054    /**
    055     * A needle in the shape of a pointer, for use with the
    056     * {@link org.jfree.chart.plot.CompassPlot} class.
    057     */
    058    public class PointerNeedle extends MeterNeedle
    059                               implements Cloneable, Serializable {
    060
    061        /** For serialization. */
    062        private static final long serialVersionUID = -4744677345334729606L;
    063
    064        /**
    065         * Draws the needle.
    066         *
    067         * @param g2  the graphics device.
    068         * @param plotArea  the plot area.
    069         * @param rotate  the rotation point.
    070         * @param angle  the angle.
    071         */
    072        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    073                                  Point2D rotate, double angle) {
    074
    075            GeneralPath shape1 = new GeneralPath();
    076            GeneralPath shape2 = new GeneralPath();
    077            float minX = (float) plotArea.getMinX();
    078            float minY = (float) plotArea.getMinY();
    079            float maxX = (float) plotArea.getMaxX();
    080            float maxY = (float) plotArea.getMaxY();
    081            float midX = (float) (minX + (plotArea.getWidth() / 2));
    082            float midY = (float) (minY + (plotArea.getHeight() / 2));
    083
    084            shape1.moveTo(minX, midY);
    085            shape1.lineTo(midX, minY);
    086            shape1.lineTo(maxX, midY);
    087            shape1.closePath();
    088
    089            shape2.moveTo(minX, midY);
    090            shape2.lineTo(midX, maxY);
    091            shape2.lineTo(maxX, midY);
    092            shape2.closePath();
    093
    094            if ((rotate != null) && (angle != 0)) {
    095                /// we have rotation huston, please spin me
    096                getTransform().setToRotation(angle, rotate.getX(), rotate.getY());
    097                shape1.transform(getTransform());
    098                shape2.transform(getTransform());
    099            }
    100
    101            if (getFillPaint() != null) {
    102                g2.setPaint(getFillPaint());
    103                g2.fill(shape1);
    104            }
    105
    106            if (getHighlightPaint() != null) {
    107                g2.setPaint(getHighlightPaint());
    108                g2.fill(shape2);
    109            }
    110
    111            if (getOutlinePaint() != null) {
    112                g2.setStroke(getOutlineStroke());
    113                g2.setPaint(getOutlinePaint());
    114                g2.draw(shape1);
    115                g2.draw(shape2);
    116            }
    117        }
    118
    119        /**
    120         * Tests another object for equality with this object.
    121         *
    122         * @param obj  the object to test (<code>null</code> permitted).
    123         *
    124         * @return A boolean.
    125         */
    126        public boolean equals(Object obj) {
    127            if (obj == this) {
    128                return true;
    129            }
    130            if (!(obj instanceof PointerNeedle)) {
    131                return false;
    132            }
    133            if (!super.equals(obj)) {
    134                return false;
    135            }
    136            return true;
    137        }
    138
    139        /**
    140         * Returns a hash code for this instance.
    141         *
    142         * @return A hash code.
    143         */
    144        public int hashCode() {
    145            return super.hashCode();
    146        }
    147
    148        /**
    149         * Returns a clone of this needle.
    150         *
    151         * @return A clone.
    152         *
    153         * @throws CloneNotSupportedException if the <code>PointerNeedle</code>
    154         *     cannot be cloned (in theory, this should not happen).
    155         */
    156        public Object clone() throws CloneNotSupportedException {
    157            return super.clone();
    158        }
    159
    160    }